Index: trunk/source/processes/hadronic/cross_sections/include/G4GlauberGribovCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4GlauberGribovCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4GlauberGribovCrossSection.hh	(revision 1340)
@@ -47,4 +47,5 @@
 #include "G4Proton.hh"
 #include "G4Nucleus.hh"
+#include "G4HadTmpUtil.hh"
 
 #include "G4VCrossSectionDataSet.hh"
@@ -63,5 +64,5 @@
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle* aDP, G4double Z, G4double A);
+  G4bool IsIsoApplicable(const G4DynamicParticle* aDP, G4int Z, G4int A);
 
   virtual
@@ -71,7 +72,7 @@
 
   virtual
-  G4double GetIsoZACrossSection(const G4DynamicParticle*, 
-				G4double Z, G4double A, 
-				G4double aTemperature = 0.0);
+  G4double GetZandACrossSection(const G4DynamicParticle*,
+                                G4int Z, G4int A,
+                                G4double aTemperature = 0.0);
 
   virtual
@@ -83,19 +84,19 @@
   {G4cout << "G4GlauberGribovCrossSection: uses Glauber-Gribov formula"<<G4endl;}
 
-  G4double GetRatioSD(const G4DynamicParticle*, G4double At, G4double Zt);
-  G4double GetRatioQE(const G4DynamicParticle*, G4double At, G4double Zt);
+  G4double GetRatioSD(const G4DynamicParticle*, G4int At, G4int Zt);
+  G4double GetRatioQE(const G4DynamicParticle*, G4int At, G4int Zt);
 
   G4double GetHadronNucleonXsc(const G4DynamicParticle*, const G4Element*);
-  G4double GetHadronNucleonXsc(const G4DynamicParticle*, G4double At, G4double Zt);
+  G4double GetHadronNucleonXsc(const G4DynamicParticle*, G4int At, G4int Zt);
 
   G4double GetHadronNucleonXscPDG(const G4DynamicParticle*, const G4Element*);
-  G4double GetHadronNucleonXscPDG(const G4DynamicParticle*, G4double At, G4double Zt);
+  G4double GetHadronNucleonXscPDG(const G4DynamicParticle*, G4int At, G4int Zt);
 
   G4double GetHadronNucleonXscNS(const G4DynamicParticle*, const G4Element*);
-  G4double GetHadronNucleonXscNS(const G4DynamicParticle*,G4double At, G4double Zt);
+  G4double GetHadronNucleonXscNS(const G4DynamicParticle*, G4int At, G4int Zt);
 
   G4double GetHNinelasticXsc(const G4DynamicParticle*, const G4Element*);
-  G4double GetHNinelasticXsc(const G4DynamicParticle*, G4double At, G4double Zt);
-  G4double GetHNinelasticXscVU(const G4DynamicParticle*, G4double At, G4double Zt);
+  G4double GetHNinelasticXsc(const G4DynamicParticle*, G4int At, G4int Zt);
+  G4double GetHNinelasticXscVU(const G4DynamicParticle*, G4int At, G4int Zt);
 
   G4double CalculateEcmValue ( const G4double , const G4double , const G4double ); 
@@ -103,6 +104,6 @@
   G4double CalcMandelstamS( const G4double , const G4double , const G4double );
 
-  G4double GetElasticGlauberGribov(const G4DynamicParticle*,G4double Z, G4double A);
-  G4double GetInelasticGlauberGribov(const G4DynamicParticle*,G4double Z, G4double A);
+  G4double GetElasticGlauberGribov(const G4DynamicParticle*, G4int Z, G4int A);
+  G4double GetInelasticGlauberGribov(const G4DynamicParticle*, G4int Z, G4int A);
 
   G4double GetTotalGlauberGribovXsc()    { return fTotalXsc;     }; 
@@ -114,8 +115,8 @@
 
   G4double GetNucleusRadius(const G4DynamicParticle*, const G4Element*);
-  G4double GetNucleusRadius(G4double At);
-
-  inline G4double GetParticleBarCorTot( const G4ParticleDefinition* theParticle, G4double Z );
-  inline G4double GetParticleBarCorIn( const G4ParticleDefinition* theParticle, G4double Z );
+  G4double GetNucleusRadius(G4int At);
+
+  inline G4double GetParticleBarCorTot(const G4ParticleDefinition* theParticle, G4int Z);
+  inline G4double GetParticleBarCorIn(const G4ParticleDefinition* theParticle, G4int Z);
 
   inline void SetEnergyLowerLimit(G4double E ){fLowerLimit=E;};
@@ -180,8 +181,9 @@
 
 inline
-G4double G4GlauberGribovCrossSection::GetElasticGlauberGribov(
-	 const G4DynamicParticle* dp, G4double Z, G4double A)
-{
-  GetIsoZACrossSection(dp, Z, A);
+G4double
+G4GlauberGribovCrossSection::GetElasticGlauberGribov(const G4DynamicParticle* dp,
+                                                     G4int Z, G4int A)
+{
+  GetZandACrossSection(dp, Z, A);
   return fElasticXsc;
 }
@@ -190,8 +192,9 @@
 
 inline
-G4double G4GlauberGribovCrossSection::GetInelasticGlauberGribov(
-         const G4DynamicParticle* dp, G4double Z, G4double A)
-{
-  GetIsoZACrossSection(dp, Z, A);
+G4double
+G4GlauberGribovCrossSection::GetInelasticGlauberGribov(const G4DynamicParticle* dp,
+                                                       G4int Z, G4int A)
+{
+  GetZandACrossSection(dp, Z, A);
   return fInelasticXsc;
 }
@@ -204,14 +207,12 @@
 
 inline G4double G4GlauberGribovCrossSection::GetParticleBarCorTot( 
-                          const G4ParticleDefinition* theParticle, G4double Z )
-{
-  G4int iZ = G4int(Z);
-
-  if( iZ >= 2 && iZ <= 92)
+                          const G4ParticleDefinition* theParticle, G4int Z)
+{
+  if(Z >= 2 && Z <= 92)
   {
-    if(      theParticle == theProton ) return fProtonBarCorrectionTot[iZ]; 
-    else if( theParticle == theNeutron) return fNeutronBarCorrectionTot[iZ]; 
-    else if( theParticle == thePiPlus ) return fPionPlusBarCorrectionTot[iZ];
-    else if( theParticle == thePiMinus) return fPionMinusBarCorrectionTot[iZ];
+    if(      theParticle == theProton ) return fProtonBarCorrectionTot[Z]; 
+    else if( theParticle == theNeutron) return fNeutronBarCorrectionTot[Z]; 
+    else if( theParticle == thePiPlus ) return fPionPlusBarCorrectionTot[Z];
+    else if( theParticle == thePiMinus) return fPionMinusBarCorrectionTot[Z];
     else return 1.0;
   }
@@ -226,14 +227,12 @@
 
 inline G4double G4GlauberGribovCrossSection::GetParticleBarCorIn( 
-                          const G4ParticleDefinition* theParticle, G4double Z )
-{
-  G4int iZ = G4int(Z);
-
-  if( iZ >= 2 && iZ <= 92)
+                          const G4ParticleDefinition* theParticle, G4int Z)
+{
+  if(Z >= 2 && Z <= 92)
   {
-    if(      theParticle == theProton ) return fProtonBarCorrectionIn[iZ]; 
-    else if( theParticle == theNeutron) return fNeutronBarCorrectionIn[iZ]; 
-    else if( theParticle == thePiPlus ) return fPionPlusBarCorrectionIn[iZ];
-    else if( theParticle == thePiMinus) return fPionMinusBarCorrectionIn[iZ];
+    if(      theParticle == theProton ) return fProtonBarCorrectionIn[Z]; 
+    else if( theParticle == theNeutron) return fNeutronBarCorrectionIn[Z]; 
+    else if( theParticle == thePiPlus ) return fPionPlusBarCorrectionIn[Z];
+    else if( theParticle == thePiMinus) return fPionMinusBarCorrectionIn[Z];
     else return 1.0;
   }
Index: trunk/source/processes/hadronic/cross_sections/include/G4HadronCaptureDataSet.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4HadronCaptureDataSet.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4HadronCaptureDataSet.hh	(revision 1340)
@@ -23,5 +23,4 @@
 // * acceptance of all terms of the Geant4 Software license.          *
 // ********************************************************************
-//
 //
 //
@@ -64,6 +63,6 @@
    }
 
-   G4bool IsZAApplicable(const G4DynamicParticle* aParticle,
-                         G4double ZZ, G4double AA)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aParticle,
+                          G4int ZZ, G4int AA)
    {
      return theHadronCrossSections->IsApplicable(aParticle, ZZ, AA);
@@ -77,7 +76,6 @@
    }
 
-   G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle,
-                            G4double ZZ, G4double AA,
-                            G4double /*aTemperature*/)
+   G4double GetZandACrossSection(const G4DynamicParticle* aParticle,
+                                 G4int ZZ, G4int AA, G4double /*aTemperature*/)
    {
      return theHadronCrossSections->GetCaptureCrossSection(aParticle, ZZ, AA);
Index: trunk/source/processes/hadronic/cross_sections/include/G4HadronCrossSections.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4HadronCrossSections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4HadronCrossSections.hh	(revision 1340)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 //
@@ -55,5 +55,5 @@
 #include "G4VProcess.hh"
 #include "G4DynamicParticle.hh"
-//#include "G4ParticleTypes.hh"
+#include "G4HadTmpUtil.hh"
 #include "G4PionPlus.hh"
 #include "G4PionZero.hh"
@@ -84,5 +84,4 @@
 #include "G4OmegaMinus.hh"
 #include "G4AntiOmegaMinus.hh"
-//#include "G4LPhysicsFreeVector.hh"
 
 
@@ -95,10 +94,8 @@
    G4HadronCrossSections()
      : prevParticleDefinition(0), lastEkx(0.), lastEkxPower(0.), verboseLevel(0)
-   {
-   }
+   {}
 
    ~G4HadronCrossSections()
-   {
-   }
+   {}
 
    static G4HadronCrossSections* Instance()
@@ -123,5 +120,5 @@
 
    G4double GetElasticCrossSection(const G4DynamicParticle*,
-                                   G4double /*ZZ*/, G4double /*AA*/);
+                                   G4int /*ZZ*/, G4int /*AA*/);
 
    G4double GetInelasticCrossSection(const G4DynamicParticle*, 
@@ -129,25 +126,27 @@
 
    G4double GetInelasticCrossSection(const G4DynamicParticle*,
-                                     G4double /*ZZ*/, G4double /*AA*/);
+                                     G4int /*ZZ*/, G4int /*AA*/);
 
    G4double GetCaptureCrossSection(const G4DynamicParticle* aParticle,
                                    const G4Element* anElement)
    {
-     return GetCaptureCrossSection(aParticle, anElement->GetZ(),
-                                              anElement->GetN());
+     G4int Z = G4lrint(anElement->GetZ());
+     G4int A = G4lrint(anElement->GetN());
+     return GetCaptureCrossSection(aParticle, Z, A);
    }
 
    G4double GetCaptureCrossSection(const G4DynamicParticle*,
-                                   G4double /*ZZ*/, G4double /*AA*/);
+                                   G4int /*ZZ*/, G4int /*AA*/);
 
    G4double GetFissionCrossSection(const G4DynamicParticle* aParticle,
                                    const G4Element* anElement)
    {
-     return GetFissionCrossSection(aParticle, anElement->GetZ(),
-                                              anElement->GetN());
+     G4int Z = G4lrint(anElement->GetZ());
+     G4int A = G4lrint(anElement->GetN());
+     return GetFissionCrossSection(aParticle, Z, A);
    }
 
    G4double GetFissionCrossSection(const G4DynamicParticle*,
-                                   G4double /*ZZ*/, G4double /*AA*/);
+                                   G4int /*ZZ*/, G4int /*AA*/);
 
 
@@ -177,5 +176,5 @@
 
    void CalcScatteringCrossSections(const G4DynamicParticle*, 
-                                    G4double /*ZZ*/, G4double /*AA*/);
+                                    G4int /*ZZ*/, G4int /*AA*/);
 
    static G4HadronCrossSections* theInstance;
@@ -199,5 +198,4 @@
    static G4float csin[NPARTS][TSIZE];
 
-
    static G4float cspiel[3][TSIZE];
    static G4float cspiin[3][TSIZE];
Index: trunk/source/processes/hadronic/cross_sections/include/G4HadronElasticDataSet.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4HadronElasticDataSet.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4HadronElasticDataSet.hh	(revision 1340)
@@ -63,6 +63,6 @@
    }
 
-   G4bool IsZAApplicable(const G4DynamicParticle* aParticle,
-                         G4double ZZ, G4double AA)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aParticle,
+                          G4int ZZ, G4int AA)
    {
      return theHadronCrossSections->IsApplicable(aParticle, ZZ, AA);
@@ -77,7 +77,7 @@
    }
 
-   G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle,
-                            G4double ZZ, G4double AA,
-                            G4double /*aTemperature*/)
+   G4double GetZandACrossSection(const G4DynamicParticle* aParticle,
+                                 G4int ZZ, G4int AA,
+                                 G4double /*aTemperature*/)
    {
      return theHadronCrossSections->GetElasticCrossSection(aParticle, ZZ, AA);
Index: trunk/source/processes/hadronic/cross_sections/include/G4HadronFissionDataSet.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4HadronFissionDataSet.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4HadronFissionDataSet.hh	(revision 1340)
@@ -62,6 +62,6 @@
    }
 
-   G4bool IsZAApplicable(const G4DynamicParticle* aParticle,
-                         G4double ZZ, G4double AA)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aParticle,
+                          G4int ZZ, G4int AA)
    {
      return theHadronCrossSections->IsApplicable(aParticle, ZZ, AA);
@@ -76,7 +76,7 @@
    }
 
-   G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle,
-                            G4double ZZ, G4double AA,
-                            G4double /*aTemperature*/)
+   G4double GetZandACrossSection(const G4DynamicParticle* aParticle,
+                                 G4int ZZ, G4int AA,
+                                 G4double /*aTemperature*/)
    {
      return theHadronCrossSections->GetFissionCrossSection(aParticle, ZZ, AA);
Index: trunk/source/processes/hadronic/cross_sections/include/G4HadronInelasticDataSet.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4HadronInelasticDataSet.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4HadronInelasticDataSet.hh	(revision 1340)
@@ -63,6 +63,6 @@
 
 
-   G4bool IsZAApplicable(const G4DynamicParticle* aParticle,
-                         G4double ZZ, G4double AA)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aParticle,
+                          G4int ZZ, G4int AA)
    {
      return theHadronCrossSections->IsApplicable(aParticle, ZZ, AA);
@@ -77,7 +77,7 @@
    }
 
-   G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle,
-                            G4double ZZ, G4double AA,
-                            G4double /*aTemperature*/)
+   G4double GetZandACrossSection(const G4DynamicParticle* aParticle,
+                                 G4int ZZ, G4int AA,
+                                 G4double /*aTemperature*/)
    {
      return theHadronCrossSections->GetInelasticCrossSection(aParticle, ZZ, AA);
Index: trunk/source/processes/hadronic/cross_sections/include/G4HadronNucleonXsc.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4HadronNucleonXsc.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4HadronNucleonXsc.hh	(revision 1340)
@@ -31,6 +31,4 @@
 //
 //
-//
-//
 // 14.03.07 V. Grichine - first implementation
 //
@@ -59,5 +57,5 @@
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle* aDP, G4double Z, G4double A);
+  G4bool IsIsoApplicable(const G4DynamicParticle* aDP, G4int Z, G4int A);
 
   virtual
Index: trunk/source/processes/hadronic/cross_sections/include/G4IonProtonCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4IonProtonCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4IonProtonCrossSection.hh	(revision 1340)
@@ -24,68 +24,69 @@
 // ********************************************************************
 //
-#ifndef G4IonProtonCrossSection_h
-#define G4IonProtonCrossSection_h
-
-#include "globals.hh"
-#include "G4Proton.hh"
-// Class Description
+// $Id: G4IonProtonCrossSection.hh,v 1.12 2010/10/15 21:05:10 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class header file
+//
+// File name:    G4IonProtonCrossSection
+//
+//
 // Cross-sections for ion proton scattering up to 20 GeV, getting the low
 // energy threshold behaviour right.
 // H.P. Wellisch (TRIUMF), D. Axen (British Columbia U.). 1996. 
 // Published in Phys.Rev.C54:1329-1332,1996 
-// Class Description - End
+//
+// Original by H.P.Wellisch 28 June 2001
+//
+// Modifications:
+// 30-07-2010 V.Ivanchenko move virtual methods to source,
+//                         add constructor and destructor,
+//                         make G4ProtonInelasticCrossSection class member,
+//                         fix bug in kinematics
+//
+
+#ifndef G4IonProtonCrossSection_h
+#define G4IonProtonCrossSection_h 1
 
 #include "G4VCrossSectionDataSet.hh"
-#include "G4ProtonInelasticCrossSection.hh"
+#include "globals.hh"
+
+class G4ProtonInelasticCrossSection;
 
 class G4IonProtonCrossSection : public G4VCrossSectionDataSet
 {
-   public:
+public:
 
-   virtual
-   G4bool IsZAApplicable(const G4DynamicParticle* aPart, G4double /*ZZ*/,
-                         G4double AA)
-   {
-     G4bool result = false;
-     if((AA < 1.1) &&
-        ( aPart->GetKineticEnergy()/aPart->GetDefinition()
-                                         ->GetBaryonNumber() < 20*GeV &&
-	  aPart->GetDefinition()->GetBaryonNumber() > 4)
-       ) result = true;
-     return result;
-   }
+  G4IonProtonCrossSection();
 
-   virtual
-   G4bool IsApplicable(const G4DynamicParticle* aPart, const G4Element* anEle)
-   {
-     return IsZAApplicable(aPart, 0., anEle->GetN());
-   }
+  virtual ~G4IonProtonCrossSection();
 
-   virtual
-   G4double GetCrossSection(const G4DynamicParticle* aPart, 
-                            const G4Element*, G4double )
-   {
-     return GetIsoZACrossSection(aPart, 0., 0., 0.);
-   }
+  virtual
+  G4bool IsApplicable(const G4DynamicParticle* aPart, const G4Element* anEle);
 
-   virtual
-   G4double GetIsoZACrossSection(const G4DynamicParticle* aPart, 
-                                 G4double /*ZZ*/, G4double /*AA*/, 
-                                 G4double /*temperature*/)
-   {
-     G4ProtonInelasticCrossSection theForward;
-     return theForward.GetCrossSection(aPart->GetKineticEnergy(),
-                                  aPart->GetDefinition()->GetBaryonNumber(),
-				  aPart->GetDefinition()->GetPDGCharge());
-   }
+  virtual
+  G4bool IsIsoApplicable(const G4DynamicParticle* aPart,
+                         G4int Z, G4int A);
 
+  virtual
+  G4double GetCrossSection(const G4DynamicParticle* aPart, 
+			   const G4Element*, G4double);
+  
+  virtual
+  G4double GetZandACrossSection(const G4DynamicParticle* aPart, 
+				G4int Z=1, G4int A=1, G4double T=0.);
 
-   virtual
-   void BuildPhysicsTable(const G4ParticleDefinition&)
-   {}
+  virtual void BuildPhysicsTable(const G4ParticleDefinition&);
 
-   virtual
-   void DumpPhysicsTable(const G4ParticleDefinition&)
-   {G4cout << "G4IonProtonCrossSection: uses formula"<<G4endl;}
+  virtual void DumpPhysicsTable(const G4ParticleDefinition&);
+
+private: // Without Description
+
+  G4IonProtonCrossSection & operator=(const G4IonProtonCrossSection &right);
+  G4IonProtonCrossSection(const G4IonProtonCrossSection&);
+
+  G4ProtonInelasticCrossSection* theForward;
 
 };
Index: trunk/source/processes/hadronic/cross_sections/include/G4IonsKoxCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4IonsKoxCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4IonsKoxCrossSection.hh	(revision 1340)
@@ -57,10 +57,11 @@
    G4bool IsApplicable(const G4DynamicParticle* aDP, const G4Element*)
    {
-     return IsZAApplicable(aDP, 0., 0.);
+     return IsIsoApplicable(aDP, 0, 0);
    }
-   
+
+
    virtual
-   G4bool IsZAApplicable(const G4DynamicParticle* aDP, G4double /*ZZ*/,
-                       G4double /*AA*/) 
+   G4bool IsIsoApplicable(const G4DynamicParticle* aDP,
+                          G4int /*ZZ*/, G4int /*AA*/) 
    {
       G4int baryonNumber = aDP->GetDefinition()->GetBaryonNumber();
@@ -71,11 +72,13 @@
    }
 
+
    virtual
    G4double GetCrossSection(const G4DynamicParticle*, 
                             const G4Element*, G4double aTemperature);
 
+
    virtual
-   G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double ZZ,
-                                 G4double AA, G4double aTemperature);
+   G4double GetZandACrossSection(const G4DynamicParticle*, G4int ZZ,
+                                 G4int AA, G4double aTemperature);
 
    virtual
Index: trunk/source/processes/hadronic/cross_sections/include/G4IonsShenCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4IonsShenCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4IonsShenCrossSection.hh	(revision 1340)
@@ -61,16 +61,16 @@
    G4bool IsApplicable(const G4DynamicParticle* aDP, const G4Element*)
    {
-      return IsZAApplicable(aDP, 0., 0.);
+     return IsIsoApplicable(aDP, 0, 0);
    }
 
    virtual
-   G4bool IsZAApplicable(const G4DynamicParticle* aDP,
-                         G4double /*ZZ*/, G4double /*AA*/)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aDP,
+                          G4int /*ZZ*/, G4int /*AA*/)
    {
-      G4int baryonNumber = aDP->GetDefinition()->GetBaryonNumber();
-      G4double kineticEnergy = aDP->GetKineticEnergy(); 
-      if ( kineticEnergy / baryonNumber <= upperLimit ) 
-         return true;
-      return false;
+     G4int baryonNumber = aDP->GetDefinition()->GetBaryonNumber();
+     G4double kineticEnergy = aDP->GetKineticEnergy(); 
+     if ( kineticEnergy / baryonNumber <= upperLimit ) 
+        return true;
+     return false;
    }
 
@@ -81,6 +81,6 @@
 
    virtual
-   G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double ZZ, 
-                                 G4double AA, G4double aTemperature);
+   G4double GetZandACrossSection(const G4DynamicParticle*, G4int ZZ, 
+                                 G4int AA, G4double aTemperature);
 
    virtual
@@ -97,6 +97,6 @@
       const G4double r0;
 
-      G4double calEcmValue ( const G4double , const G4double , const G4double ); 
-      G4double calCeValue ( const G4double ); 
+      G4double calEcmValue(const G4double, const G4double, const G4double); 
+      G4double calCeValue(const G4double); 
 };
 
Index: trunk/source/processes/hadronic/cross_sections/include/G4IonsSihverCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4IonsSihverCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4IonsSihverCrossSection.hh	(revision 1340)
@@ -54,10 +54,10 @@
    G4bool IsApplicable(const G4DynamicParticle* aDP, const G4Element*)
    {
-     return IsZAApplicable(aDP, 0., 0.);
+     return IsIsoApplicable(aDP, 0, 0);
    }
 
    virtual 
-   G4bool IsZAApplicable(const G4DynamicParticle* aDP, G4double /*ZZ*/, 
-                         G4double /*AA*/)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aDP, G4int /*ZZ*/, 
+                          G4int /*AA*/)
    {
       G4int BaryonNumber = aDP->GetDefinition()->GetBaryonNumber();
@@ -73,6 +73,6 @@
 
    virtual
-   G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double ZZ, 
-                                 G4double AA, G4double aTemperature);
+   G4double GetZandACrossSection(const G4DynamicParticle*, G4int ZZ, 
+                                 G4int AA, G4double aTemperature);
 
    virtual
Index: trunk/source/processes/hadronic/cross_sections/include/G4NeutronCaptureXS.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4NeutronCaptureXS.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4NeutronCaptureXS.hh	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NeutronCaptureXS.hh,v 1.1 2009/11/12 00:36:01 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NeutronCaptureXS.hh,v 1.4 2010/10/15 22:32:40 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -38,6 +38,10 @@
 // Modifications:
 //
+
+// Class Description:
+// This is a base class for neutron radiative capture cross section based on
+// data files from G4NEUTRONXSDATA data set 
+// Class Description - End
  
-
 #ifndef G4NeutronCaptureXS_h
 #define G4NeutronCaptureXS_h 1
@@ -45,4 +49,5 @@
 #include "G4VCrossSectionDataSet.hh"
 #include "globals.hh"
+#include <vector>
 
 class G4DynamicParticle;
@@ -55,16 +60,13 @@
 public: // With Description
 
-  G4int Z;
   G4NeutronCaptureXS();
 
   virtual ~G4NeutronCaptureXS();
 
-  // The following methods need to be implemented for each new data set.
   virtual
   G4bool IsApplicable(const G4DynamicParticle*, const G4Element*);
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle*, 
-			G4double /*Z*/, G4double /*A*/);
+  G4bool IsIsoApplicable(const G4DynamicParticle*, G4int /*Z*/, G4int /*A*/);
 
   virtual
@@ -79,17 +81,5 @@
   void DumpPhysicsTable(const G4ParticleDefinition&);
 
-
-public: // Without Description
-
-  inline void SetVerboseLevel(G4int value)
-  {
-    verboseLevel = value;
-  }
-  inline G4int GetVerboseLevel()
-  {
-    return verboseLevel;
-  }
-
-private: // Without Description
+private: 
 
   void Initialise(G4int Z, const char* = 0);
@@ -98,6 +88,7 @@
   G4NeutronCaptureXS(const G4NeutronCaptureXS&);
 
-  G4double         emax;
-  G4PhysicsVector* data[93];
+  G4double emax;
+  G4int    maxZ;
+  std::vector<G4PhysicsVector*> data;
 
   G4bool  isInitialized;
Index: trunk/source/processes/hadronic/cross_sections/include/G4NeutronElasticXS.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4NeutronElasticXS.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4NeutronElasticXS.hh	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NeutronElasticXS.hh,v 1.3 2009/11/19 11:51:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NeutronElasticXS.hh,v 1.6 2010/10/15 22:32:55 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -39,4 +39,8 @@
 //
  
+// Class Description:
+// This is a base class for neutron elastic hadronic cross section based on
+// data files from G4NEUTRONXSDATA data set 
+// Class Description - End
 
 #ifndef G4NeutronElasticXS_h
@@ -45,4 +49,5 @@
 #include "G4VCrossSectionDataSet.hh"
 #include "globals.hh"
+#include <vector>
 
 class G4DynamicParticle;
@@ -51,4 +56,5 @@
 class G4PhysicsVector;
 class G4GlauberGribovCrossSection;
+class G4HadronNucleonXsc;
 
 class G4NeutronElasticXS : public G4VCrossSectionDataSet
@@ -56,16 +62,13 @@
 public: // With Description
 
-  G4int Z;
   G4NeutronElasticXS();
 
   virtual ~G4NeutronElasticXS();
 
-  // The following methods need to be implemented for each new data set.
   virtual
   G4bool IsApplicable(const G4DynamicParticle*, const G4Element*);
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle*, 
-			G4double /*Z*/, G4double /*A*/);
+  G4bool IsIsoApplicable(const G4DynamicParticle*, G4int /*Z*/, G4int /*A*/);
 
   virtual
@@ -80,16 +83,5 @@
   void DumpPhysicsTable(const G4ParticleDefinition&);
 
-public: // Without Description
-
-  inline void SetVerboseLevel(G4int value)
-  {
-    verboseLevel = value;
-  }
-  inline G4int GetVerboseLevel()
-  {
-    return verboseLevel;
-  }
-
-private: // Without Description
+private: 
 
   void Initialise(G4int Z, G4DynamicParticle* dp = 0, const char* = 0);
@@ -99,7 +91,11 @@
   
   G4GlauberGribovCrossSection* ggXsection;
+  G4HadronNucleonXsc* fNucleon;
 
-  G4PhysicsVector* data[93];
-  G4double         coeff[93];
+  const G4ParticleDefinition* proton;
+
+  std::vector<G4PhysicsVector*> data;
+  std::vector<G4double>         coeff;
+  G4int   maxZ;
 
   G4bool  isInitialized;
Index: trunk/source/processes/hadronic/cross_sections/include/G4NeutronInelasticCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4NeutronInelasticCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4NeutronInelasticCrossSection.hh	(revision 1340)
@@ -58,6 +58,6 @@
    }
 
-   G4bool IsZAApplicable(const G4DynamicParticle* aPart,
-                         G4double ZZ, G4double /*AA*/)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aPart,
+                          G4int ZZ, G4int /*AA*/)
    {
      G4bool result = false;
@@ -74,6 +74,6 @@
                             const G4Element*, G4double aTemperature);
 
-   G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle,
-                                 G4double ZZ, G4double AA,
+   G4double GetZandACrossSection(const G4DynamicParticle* aParticle,
+                                 G4int ZZ, G4int AA,
                                  G4double /*aTemperature*/)
    {
@@ -82,5 +82,6 @@
   
 
-   G4double GetCrossSection(G4double anEnergy, G4double anA, G4double aZ);
+   G4double GetCrossSection(G4double anEnergy, G4int anA, G4int aZ);
+
 
    virtual
